#include "obj03_db_api.h"
#include "obj03_db_dbd.h"

using namespace RDM_CPP;

Db_obj03_db Db_obj03_db::Open (char *mode) throw (rdm_exception&) {
    return Db::Open (Type (), "obj03_db", mode, &obj03_db_dbd, sizeof(obj03_db_dbd));
}

#if !defined(RDM_NO_UNICODE)
Db_obj03_db Db_obj03_db::Open (wchar_t *mode) throw (rdm_exception&) {
    return Db::Open (Type (), L"obj03_db", mode, &obj03_db_dbd, sizeof(obj03_db_dbd));
}
#endif /*RDM_NO_UNICODE*/

Db_obj03_db Db_obj03_db::Open (const char *name, const char *mode) throw (rdm_exception&) {
    return Db::Open (Type (), name, mode, &obj03_db_dbd, sizeof(obj03_db_dbd));
}

#if !defined(RDM_NO_UNICODE)
Db_obj03_db Db_obj03_db::Open (const wchar_t *name, const wchar_t *mode) throw (rdm_exception&) {
    return Db::Open (Type (), name, mode, &obj03_db_dbd, sizeof(obj03_db_dbd));
}
#endif /*RDM_NO_UNICODE*/

dbType Db_obj03_db::Type (void) {
    char static type;
    return &type;
}

Db_obj03_db::Db_obj03_db (void) throw () {
}

Db_obj03_db::Db_obj03_db (const Db& db) throw () : Db (db, Type()) {
}

Db_obj03_db::Db_obj03_db (const Db_obj03_db& db) throw () : Db (db) {
}

Db_obj03_db::Db_obj03_db (IDb *idb) : Db (idb) {
}

Db_obj03_db& Db_obj03_db::operator = (const Db& db) throw (rdm_exception&) {
    AssignAndVerifyType (Type (), db);
    return *this;
}

Db_obj03_db& Db_obj03_db::operator = (const Db_obj03_db& db) throw () {
    *((Db *)this) = db;
    return *this;
}

Db_obj03_db::~Db_obj03_db () {
}

Cursor_artist Db_obj03_db::New_artist_record (void) const throw (rdm_exception&) {
    return Cursor_artist (NewRecords (Cursor_artist::Type ()));
}

Cursor_artist Db_obj03_db::New_artist_recordWithFieldValues (struct artist *fields) const throw (rdm_exception&) {
    return Cursor_artist (NewRecordsWithFieldValues (Cursor_artist::Type (), fields));
}

Cursor_album Db_obj03_db::New_album_record (void) const throw (rdm_exception&) {
    return Cursor_album (NewRecords (Cursor_album::Type ()));
}

Cursor_album Db_obj03_db::New_album_recordWithFieldValues (struct album *fields) const throw (rdm_exception&) {
    return Cursor_album (NewRecordsWithFieldValues (Cursor_album::Type (), fields));
}

Cursor_artist Db_obj03_db::Get_artist_records (void) const throw (rdm_exception&) {
    return Cursor_artist (GetRecords (Cursor_artist::Type ()));
}

Cursor_album Db_obj03_db::Get_album_records (void) const throw (rdm_exception&) {
    return Cursor_album (GetRecords (Cursor_album::Type ()));
}

recordType Cursor_artist::Type (void) {
    return ARTIST;
}

Cursor_artist::Cursor_artist (void) throw () {
}

Cursor_artist::Cursor_artist (const Cursor& cursor) throw (rdm_exception&) : Cursor (cursor, Type ()) {
}

Cursor_artist::Cursor_artist (const Cursor_artist& cursor) throw () : Cursor (cursor) {
}

Cursor_artist& Cursor_artist::operator = (const Cursor& cursor) throw (rdm_exception&) {
    AssignAndVerifyType (Type (), cursor);
    return *this;
}

Cursor_artist& Cursor_artist::operator = (const Cursor_artist& cursor) throw () {
    *((Cursor *)this) = cursor;
    return *this;
}

Cursor_album Cursor_artist::Get_artist_album_members (void) const throw (rdm_exception&) {
    return GetMembers (ARTIST_ALBUM);
}

int32_t Cursor_artist::Get_artist_album_count (void) const throw (rdm_exception&) {
    return GetMemberCount (ARTIST_ALBUM);
}

void Cursor_artist::SetFieldValues (const struct artist *fields) const throw (rdm_exception&) {
    Cursor::SetFieldValues (Type (), fields);
}

void Cursor_artist::GetFieldValues (struct artist *fields) const throw (rdm_exception&) {
    Cursor::GetFieldValues (Type (), fields);
}

void Cursor_artist::Set_name (const char name_val[100]) const throw (rdm_exception&) {
    SetField (NAME, name_val);
}

void Cursor_artist::Get_name (char name_val[100]) const throw (rdm_exception&) {
    GetField (NAME, name_val);
}

Cursor_artist::~Cursor_artist () {
}

recordType Cursor_album::Type (void) {
    return ALBUM;
}

Cursor_album::Cursor_album (void) throw () {
}

Cursor_album::Cursor_album (const Cursor& cursor) throw (rdm_exception&) : Cursor (cursor, Type ()) {
}

Cursor_album::Cursor_album (const Cursor_album& cursor) throw () : Cursor (cursor) {
}

Cursor_album& Cursor_album::operator = (const Cursor& cursor) throw (rdm_exception&) {
    AssignAndVerifyType (Type (), cursor);
    return *this;
}

Cursor_album& Cursor_album::operator = (const Cursor_album& cursor) throw () {
    *((Cursor *)this) = cursor;
    return *this;
}

Cursor_album Cursor_album::Get_artist_album_siblings (void) const throw (rdm_exception&) {
    return GetSiblings (ARTIST_ALBUM);
}

void Cursor_album::Connect_artist_album (const Cursor_artist &owner) const throw (rdm_exception&) {
    Connect (ARTIST_ALBUM, owner, FALSE);
}

void Cursor_album::Reconnect_artist_album (const Cursor_artist &owner) const throw (rdm_exception&) {
    Connect (ARTIST_ALBUM, owner, TRUE);
}

void Cursor_album::Disconnect_artist_album (void) const throw (rdm_exception&) {
    Disconnect (ARTIST_ALBUM);
}

Cursor_artist Cursor_album::Get_artist_album_owner (void) const throw (rdm_exception&) {
    return GetOwner (ARTIST_ALBUM);
}

void Cursor_album::SetFieldValues (const struct album *fields) const throw (rdm_exception&) {
    Cursor::SetFieldValues (Type (), fields);
}

void Cursor_album::GetFieldValues (struct album *fields) const throw (rdm_exception&) {
    Cursor::GetFieldValues (Type (), fields);
}

void Cursor_album::Set_title (const char title_val[100]) const throw (rdm_exception&) {
    SetField (TITLE, title_val);
}

void Cursor_album::Get_title (char title_val[100]) const throw (rdm_exception&) {
    GetField (TITLE, title_val);
}

Cursor_album::~Cursor_album () {
}

